io.vertx.micrometer

## Class MicrometerMetricsOptions

- java.lang.Object
- - io.vertx.core.metrics.MetricsOptions
  - - io.vertx.micrometer.MicrometerMetricsOptions

-     public class MicrometerMetricsOptions
      extends MetricsOptions

  Vert.x micrometer configuration.

  It is required to set either `influxDbOptions`, `prometheusOptions` or `jmxMetricsOptions` (or, programmatically, `micrometerRegistry`) in order to actually report metrics.

  Author:
    Joel Takvorian

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `DEFAULT_JVM_METRICS_ENABLED` Whether JVM metrics should be collected by default = false.
    `static List<Label>` | `DEFAULT_LABELS` Default label match for public http server: exclude remote label
    `static String` | `DEFAULT_REGISTRY_NAME` Default registry name is 'default'

    - ### Fields inherited from class io.vertx.core.metrics.MetricsOptions

      `DEFAULT_METRICS_ENABLED`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MicrometerMetricsOptions()` Creates default options for Micrometer metrics.
    `MicrometerMetricsOptions(JsonObject json)` Creates new options object for Micrometer metrics from `json` input.
    `MicrometerMetricsOptions(MicrometerMetricsOptions other)` Creates new options object for Micrometer metrics, which is a copy of `other`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MicrometerMetricsOptions` | `addDisabledMetricsCategory(MetricsDomain metricsDomain)` Set metric that will not be registered.
    `MicrometerMetricsOptions` | `addLabelMatch(Match match)` Add a rule for label matching.
    `MicrometerMetricsOptions` | `addLabels(Label... labels)` Add a labels to enable.
    `Set<MetricsDomain>` | `getDisabledMetricsCategories()`
    `VertxInfluxDbOptions` | `getInfluxDbOptions()` Get the specific options for InfluxDB reporting.
    `VertxJmxMetricsOptions` | `getJmxMetricsOptions()` Get the specific options for JMX reporting.
    `List<Match>` | `getLabelMatches()`
    `Set<Label>` | `getLabels()`
    `io.micrometer.core.instrument.MeterRegistry` | `getMicrometerRegistry()` Get the Micrometer MeterRegistry to be used by Vert.x, that has been previously set programmatically
    `VertxPrometheusOptions` | `getPrometheusOptions()` Get the specific options for Prometheus reporting.
    `String` | `getRegistryName()` Get the metrics registry name set in these options
    `boolean` | `isJvmMetricsEnabled()`
    `boolean` | `isMetricsCategoryDisabled(MetricsDomain metricsDomain)` Is the given metrics category disabled?
    `MicrometerMetricsOptions` | `setDisabledMetricsCategories(Set<MetricsDomain> disabledMetricsCategories)` Sets metrics types that are disabled.
    `MicrometerMetricsOptions` | `setEnabled(boolean enable)` Set whether metrics will be enabled on the Vert.x instance.
    `MicrometerMetricsOptions` | `setInfluxDbOptions(VertxInfluxDbOptions influxDbOptions)` Set InfluxDB options.
    `MicrometerMetricsOptions` | `setJmxMetricsOptions(VertxJmxMetricsOptions jmxMetricsOptions)` Set JMX metrics options.
    `MicrometerMetricsOptions` | `setJvmMetricsEnabled(boolean jvmMetricsEnabled)` Whether JVM metrics should be collected.
    `MicrometerMetricsOptions` | `setLabelMatches(List<Match> matches)` Set a list of rules for label matching.
    `MicrometerMetricsOptions` | `setLabels(Set<Label> labels)` Sets enabled labels.
    `MicrometerMetricsOptions` | `setMicrometerRegistry(io.micrometer.core.instrument.MeterRegistry micrometerRegistry)` Programmatically set the Micrometer MeterRegistry to be used by Vert.x.
    `MicrometerMetricsOptions` | `setPrometheusOptions(VertxPrometheusOptions prometheusOptions)` Set Prometheus options.
    `MicrometerMetricsOptions` | `setRegistryName(String registryName)` Set a name for the metrics registry, so that a new registry will be created and associated with this name.
    `JsonObject` | `toJson()`

    - ### Methods inherited from class io.vertx.core.metrics.MetricsOptions

      `equals, getFactory, hashCode, isEnabled, setFactory, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_REGISTRY_NAME

          public static final String DEFAULT_REGISTRY_NAME

      Default registry name is 'default'
      See Also:
        Constant Field Values

    - #### DEFAULT_LABELS

          public static final List<Label> DEFAULT_LABELS

      Default label match for public http server: exclude remote label

    - #### DEFAULT_JVM_METRICS_ENABLED

          public static final boolean DEFAULT_JVM_METRICS_ENABLED

      Whether JVM metrics should be collected by default = false.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MicrometerMetricsOptions

          public MicrometerMetricsOptions()

      Creates default options for Micrometer metrics.

    - #### MicrometerMetricsOptions

          public MicrometerMetricsOptions(MicrometerMetricsOptions other)

      Creates new options object for Micrometer metrics, which is a copy of `other`.

    - #### MicrometerMetricsOptions

          public MicrometerMetricsOptions(JsonObject json)

      Creates new options object for Micrometer metrics from `json` input.

  - ### Method Detail

    - #### toJson

          public JsonObject toJson()

      Overrides:
        `toJson` in class `MetricsOptions`
      Returns:
        a JSON representation of these options

    - #### setEnabled

          public MicrometerMetricsOptions setEnabled(boolean enable)

      Set whether metrics will be enabled on the Vert.x instance. Metrics are not enabled by default.
      Overrides:
        `setEnabled` in class `MetricsOptions`
      Parameters:
        `enable` - true if metrics enabled, or false if not.
      Returns:
        a reference to this, so the API can be used fluently

    - #### getDisabledMetricsCategories

          public Set<MetricsDomain> getDisabledMetricsCategories()

      Returns:
        the disabled metrics types.

    - #### setDisabledMetricsCategories

          public MicrometerMetricsOptions setDisabledMetricsCategories(Set<MetricsDomain> disabledMetricsCategories)

      Sets metrics types that are disabled.
      Parameters:
        `disabledMetricsCategories` - to specify the set of metrics types to be disabled.
      Returns:
        a reference to this, so that the API can be used fluently

    - #### addDisabledMetricsCategory

          public MicrometerMetricsOptions addDisabledMetricsCategory(MetricsDomain metricsDomain)

      Set metric that will not be registered. Schedulers will check the set `disabledMetricsCategories` when registering metrics suppliers
      Parameters:
        `metricsDomain` - the type of metrics
      Returns:
        a reference to this, so that the API can be used fluently

    - #### isMetricsCategoryDisabled

          public boolean isMetricsCategoryDisabled(MetricsDomain metricsDomain)

      Is the given metrics category disabled?
      Returns:
        true if it is disabled

    - #### getRegistryName

          public String getRegistryName()

      Get the metrics registry name set in these options

    - #### setRegistryName

          public MicrometerMetricsOptions setRegistryName(String registryName)

      Set a name for the metrics registry, so that a new registry will be created and associated with this name. If `registryName` is not provided (or null), a default registry will be used. If the same name is given to several Vert.x instances (within the same JVM), they will share the same registry.
      Parameters:
        `registryName` - a name to uniquely identify this registry

    - #### getLabels

          public Set<Label> getLabels()

      Returns:
        the enabled labels.

    - #### setLabels

          public MicrometerMetricsOptions setLabels(Set<Label> labels)

      Sets enabled labels. These labels can be fine-tuned later on using Micrometer's Meter filters (see http://micrometer.io/docs/concepts#_meter_filters)
      Parameters:
        `labels` - the set of enabled labels - this set will replace any previously enabled labels, including the default ones
      Returns:
        a reference to this, so that the API can be used fluently

    - #### addLabels

          public MicrometerMetricsOptions addLabels(Label... labels)

      Add a labels to enable. These labels can be fine-tuned later on using Micrometer's Meter filters (see http://micrometer.io/docs/concepts#_meter_filters)
      Parameters:
        `labels` - the labels to enable
      Returns:
        a reference to this, so that the API can be used fluently

    - #### getLabelMatches

          public List<Match> getLabelMatches()

      Returns:
        the list of label matching rules

    - #### setLabelMatches

          public MicrometerMetricsOptions setLabelMatches(List<Match> matches)

      Set a list of rules for label matching.
      Parameters:
        `matches` - the new list of rules
      Returns:
        a reference to this, so the API can be used fluently

    - #### addLabelMatch

          public MicrometerMetricsOptions addLabelMatch(Match match)

      Add a rule for label matching.
      Parameters:
        `match` - the label match
      Returns:
        a reference to this, so the API can be used fluently

    - #### getMicrometerRegistry

          public io.micrometer.core.instrument.MeterRegistry getMicrometerRegistry()

      Get the Micrometer MeterRegistry to be used by Vert.x, that has been previously set programmatically
      Returns:
        the micrometer registry.

    - #### setMicrometerRegistry

          public MicrometerMetricsOptions setMicrometerRegistry(io.micrometer.core.instrument.MeterRegistry micrometerRegistry)

      Programmatically set the Micrometer MeterRegistry to be used by Vert.x. This is useful in several scenarios, such as:
      - if there is already a MeterRegistry used in the application that should be used by Vert.x as well.
      - to define some backend configuration that is not covered in this module (example: reporting to non-covered backends such as New Relic)
      - to use Micrometer's CompositeRegistry
      This setter is mutually exclusive with setInfluxDbOptions/setPrometheusOptions/setJmxMetricsOptions and takes precedence over them.
      Parameters:
        `micrometerRegistry` - the registry to use
      Returns:
        a reference to this, so the API can be used fluently

    - #### getInfluxDbOptions

          public VertxInfluxDbOptions getInfluxDbOptions()

      Get the specific options for InfluxDB reporting.

    - #### setInfluxDbOptions

          public MicrometerMetricsOptions setInfluxDbOptions(VertxInfluxDbOptions influxDbOptions)

      Set InfluxDB options. Setting a registry backend option is mandatory in order to effectively report metrics.
      Parameters:
        `influxDbOptions` - backend options for InfluxDB

    - #### getPrometheusOptions

          public VertxPrometheusOptions getPrometheusOptions()

      Get the specific options for Prometheus reporting.

    - #### setPrometheusOptions

          public MicrometerMetricsOptions setPrometheusOptions(VertxPrometheusOptions prometheusOptions)

      Set Prometheus options. Setting a registry backend option is mandatory in order to effectively report metrics.
      Parameters:
        `prometheusOptions` - backend options for Prometheus

    - #### getJmxMetricsOptions

          public VertxJmxMetricsOptions getJmxMetricsOptions()

      Get the specific options for JMX reporting.

    - #### setJmxMetricsOptions

          public MicrometerMetricsOptions setJmxMetricsOptions(VertxJmxMetricsOptions jmxMetricsOptions)

      Set JMX metrics options. Setting a registry backend option is mandatory in order to effectively report metrics.
      Parameters:
        `jmxMetricsOptions` - backend options for JMX reporting

    - #### isJvmMetricsEnabled

          public boolean isJvmMetricsEnabled()

      Returns:
        true if JVM metrics should be collected, false otherwise

    - #### setJvmMetricsEnabled

          public MicrometerMetricsOptions setJvmMetricsEnabled(boolean jvmMetricsEnabled)

      Whether JVM metrics should be collected. Defaults to `false`.
      Parameters:
        `jvmMetricsEnabled` - true to collect JVM metrics, false otherwise. Defaults to `false`.
      Returns:
        a reference to this, so the API can be used fluently

Copyright © 2019 Eclipse. All rights reserved.